import json
import requests
import os
from uuid import uuid4


def read_in_chunks(file, chunk_size=5000000):
    while True:
        data = file.read(chunk_size)
        if not data:
            break
        yield data

def upload_file(file_path, path, token_yemot):
    if os.path.getsize(file_path) > 5000000:
        content_name = str(os.path.basename(file_path))
        content_path = os.path.abspath(file_path)
        content_size = os.stat(content_path).st_size
        qquuid = str(uuid4())

        file = open(content_path, 'rb')

        chunks = [chunk for chunk in read_in_chunks(file)]

        file.close()

        offset = 0
        for chunk in chunks:
            data = {
                    'token': token_yemot,
                    'path': path,
                    'qquuid': qquuid,
                    'convertAudio': 0,
                    'autoNumbering': 'true',
                    'uploader': 'yemot-admin',
                    'qqfilename': content_name,
                    'qqtotalfilesize': content_size,
                    'qqtotalparts': len(chunks),
                    'qqchunksize': len(chunk),
                    'qqpartbyteoffset': offset,
                    'qqpartindex': chunks.index(chunk),
            }
            files = {
                'qqfile': chunk,
            }
            res = requests.post('https://www.call2all.co.il/ym/api/UploadFile',
                data=data,
                files=files,
            )
            offset += len(chunk)


        response = requests.post('https://www.call2all.co.il/ym/api/UploadFile?done',{
            'token': token_yemot, 
            'path': path, 
            'uploader': 'yemot-admin',
            'convertAudio': 0,
            'autoNumbering': 'true',
            'qquuid': qquuid,
            'qqfilename': content_name,
            'qqtotalfilesize': content_size,
            'qqtotalparts': len(chunks),
        })   
        responses = response.text.split("}{")
        for idx, response in enumerate(responses):
            if idx < len(responses) - 1:
                response = f"{response}"
            else:
                response = f"{response}"
            
            try:
                data = json.loads(response)
                print(response.json())
                return data
            except json.JSONDecodeError as e:
                print("JSON decoding error:", e)
    else:
        url = 'https://www.call2all.co.il/ym/api/UploadFile'
        params = {
            'token': token_yemot,
            'path': path,
            'convertAudio': int(1),
            'autoNumbering': int(1),
        }
        files = {'file': open(file_path, 'rb')}
        response = requests.post(url, params=params, files=files)
        print(response.json())
        return response.json()
    
    

